#!/usr/bin/env perl

#
#  A Converter from Juman dic to MeCab dic
#  
# Copyright (C) 2003-2004 Taku Kudo  All rights reserved.
#   This is free software with ABSOLUTELY NO WARRANTY.
#  
# This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#  
# This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#  
# You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
#   02111-1307, USA

# TODO
# (ϢܥȽŤ 4)
# (ǥȽŤ 1)

my $PREFIX = ".";
my %COST  = %{&readJumanRc ()};
my %CTYPE = %{&readCType ()};

sub readCType
{
    my %e;
    my $ctype = "";
    open (F, "JUMAN.katuyou") || die "FATAL: $! JUMAN.katuyou\n";
    while (<F>) {
	chomp;
	next if (/^;/ || /^$/);
	if (/^\((\S+)\s*/) {
	    $ctype = $1;
	} elsif (/^\)\s*$/) {
	    $ctype = "";
	} elsif ($ctype ne "" && /^\s+\(\(?([^\)]+)\)/) {
	    my ($a,$b,$c) = split /\s+/, $1;
	    $c = $b if (! defined $c || $c eq "");
	    $b = "" if ($b eq "*");
	    $c = "" if ($c eq "*");
	    push @{$e{$ctype}}, [($a,$b,$c)];
	}
    }
    close (F);
    return \%e;
}

sub readJumanRc
{
    my %e;
    open (F, "jumanrc") || die "FATAL: $! jumanrc\n";
    while (<F>) {
	chomp;
	if (/\s+\(\(([^\)]+)\)\s+(\d+)\)/) {
	    my ($a, $b) = split / /, $1;
	    $b = "*" if (! defined $b);
	    $e{"$a $b"} = $2;
	}
    }
    close (F);
    return \%e;
}

sub readall 
{
    open (F, $_[0]) || die "FATAL: $! $_[0]\n";
    my $buf;
    while (<F>) {
	chomp;
	s/;.+$//g;
	s/^\s+//g;
	s/\s+$//g;
	while (s/\(\s+\(/\(\(/g) {};
	while (s/\)\s+\)/\)\)/g) {} ;
	while (s/\(\s+\)/\(\)/g) {};
	while (s/\s+\(/\(/g) {};
	while (s/\s+\)/\)/g) {};
	next if (/^\s*$/ || /;/);
	$buf .= $_;
    }
    close (F);
    return $buf;
}

sub append 
{
    my ($a, $b) = @_;
    return $b if ($a eq ""); 
    return $a if ($b eq "*" || $b eq "");
    return $a . $b;
}

sub convWord
{
    my @tmp = @{$_[0]};
    my $ctype = $tmp[5];
    $ctype =~ s/^\s+//g;
    $ctype =~ s/\s+$//g;
    
    my @p = keys %COST;

    my $cost = -1;
    my @cand = ("* *", "$tmp[2] *", "$tmp[2] $tmp[3]");
    for ( @cand ) {
	$cost = $COST{$_} if (defined $COST{$_}) ;
    }
    die "FATAL: Unknown Cost $tmp[2] $tmp[3]\n" if ($cost == -1);

    $tmp[1] = int ($cost * $tmp[1]);

    return ((join ",", @tmp) . "\n") if ($ctype eq "*");

    die "FATAL: Unknown ctype [$ctype]\n" if (! defined $CTYPE{$ctype}) ;

    my $lex   = $tmp[0];
    my $read  = $tmp[6];
    my $lexs  = $lex;
    my $reads = $read;
    
    # 촴Ĥ
    my @list = @{$CTYPE{$ctype}};
    for my $i (0 .. $#list) {
	if ($list[$i][0] eq "ܷ") {
	    $lexs  = substr ($lex,  0, length ($lex)  - length($list[$i][1]));
	    $reads = substr ($read, 0, length ($read) - length($list[$i][2]));
	    last;
	}
    }
    
    # Ÿ!
    my @r = ();
    my $base = "";
    for my $i (0 .. $#list) {
        my $cform   = $list[$i][0];
        my $newlex  = &append ($lexs,  $list[$i][1]);
        my $newread = &append ($reads, $list[$i][2]);
	$base = $newlex if ($cform eq "ܷ");
        next if (length ($newlex) <= 1);
	push @r, [($newlex,$tmp[1],$tmp[2],$tmp[3],$ctype,$cform,$lexs,$newread)];
    }

    die "FATAL: base form is unknown\n" if ($base eq "");

    my $result = "";
    for (@r) {
	my @l = @{$_};
	$l[6] = $base; # rewrite base
	$result .= ((join ",", @l) . "\n");
    }
    
    return $result;
}

sub convConnect
{
    my @a = split /,/, shift @_;
    my @r;
    for (@a) {
	my @t = split / /, $_;
	for my $i (0..4) {
	    $t[$i] = "*" if (!defined $t[$i]);
	}
	push @r, (join ",", @t);
    }
    return @r;
}

#################################################################################
#
# MAIN
#
my $buf = readall ("JUMAN.connect");
while ($buf =~ s/\)\(\(\(/")\n((("/eg) {};
my @rule = split /\n/, $buf;
open (S, ">connect.csv") || die "FATAL: $! connect.csv\n";
for (@rule) {
    my $cost = 10;
    if (s/\s*(\d+)\s*\)/\)/) {
	$cost = $1;
    }
    s/^\(\(//;
    s/\)\)$//;

    if (! /\)\)\(\(/) {
	s/\)\(\(/\)\)\(\(/;
	$_ = "($_";
    }

    my ($r, $l) = split /\)\)\(\(/, $_;
    $r = "$r)";
    $l = "($l";
    $r =~ s/^\(//;
    $l =~ s/^\(//;
    $r =~ s/\)$//;
    $l =~ s/\)$//;
    $r =~ s/\)\(/,/g;
    $l =~ s/\)\(/,/g;
    my @left =  &convConnect ($l);
    my @right = &convConnect ($r);

    $cost *= 4;

    for my $j (0..$#right) {
	for my $i (0..$#left) {
	    print S "\"*,*,*,*,*\",\"$right[$j]\",\"$left[$i]\",$cost\n";
	}
    }
}
close (S);

# main
opendir (DICDIR, $PREFIX) || die "FATAL: $! $PREFIX\n";
my @dic = grep (/\.dic$/, readdir (DICDIR));
open (S, ">dic.csv") || die "FATAL: $! dic.csv\n";

for my $file (@dic) {
    print "$file ...\n";
    my $buf = readall ($file);
    
    if ($file =~ /Rengo.dic/) {
	while ($buf =~ s/\(Ϣ\(/"\n"/eg) {};
    }

    while ($buf =~ s/\)\)\)\(/")))\n("/eg) {};
    my @rule = split /\n/, $buf;

    for (@rule) {
	next if (! defined $_ || $_ eq "");
	my $org = $_;
	my $pos1 = "*";
	my $pos2 = "*";

	# has subpos
	if (/^\(([^\(]+)\(([^\(]+)\(\((Ф|ɤ)/) {
	    $pos1 = $1;
	    $pos2 = $2;
	} elsif (/^\(([^\(]+)\(\((Ф|ɤ)/) {
	    $pos1 = $1;
	} else {
	    die "FATAL: Cannot parse [$org]\n";
	}

	# (ۤۤ 1.6) ν
	while (s/\(([^\)\(]+) ([\d\.]+)\)/" $1:$2 "/eg) {};

	my @list = ();
	while (1) {  
	    if (s/\(Ф ([^\)\(]+)\)\(ɤ ([^\)\(]+)\)//) {
		push @list, [($1, 1.0, $pos1, $pos2, "*", "*", $1, $2)];
	    } elsif (s/\(Ф\(([^\)\(]+) ([^\)\(]+)\)\)\(ɤ ([^\)\(]+)\)// ) {
		push @list, [($1, $2, $pos1, $pos2,  "*", "*", $1, $3)];	    
	    } elsif (s/\(ɤ ([^\)\(]+)\)\(Ф ([^\)\(]+)\)//) {
		push @list, [($2, 1.0, $pos1, $pos2, "*", "*", $2, $1)];	    
	    } elsif (s/\(ɤ ([^\)\(]+)\)\(Ф\(([^\)\(]+) ([^\)\(]+)\)\)// ) {
		push @list, [($2, $3, $pos1, $pos2,  "*", "*", $2, $1)];	    
	    } else {
		last;
	    }
	}

	die "FATAL: Cannot parse [$org]\n" if (/ɤ/ || /Ф/);

	my $i = 0;
	while (s/\(ѷ ([^\)\(]+)\)//) { $list[$i++][5] = $1; }
	die "FATAL: Cannot Parse [$org]\n" if ($i != 0 && $i != scalar (@list));
	for (@list) { 
	    my @l = @{$_};
	    my $c = $l[1];
	    my $s = $l[0];
	    for ((split /\s+/, $s)) {
		my ($a, $b) = split /:/, $_;
		$b = 1.0 if (! defined $b);
		$l[0] = $a;
		$l[6] = $a;
		$l[1] = $b * $c;
		print S &convWord (\@l); 
	    }
	}
    }
}
close (S);
